#include <cstdio>
#include <queue>

using namespace std;

int H;
int odl[44][44][44][44];
char pole[44][44];

void init()
{
	for(int i=0; i<44; ++i)
		for(int j=0; j<44; ++j)
			pole[i][j] = 0;
}

struct qq {
	int x, y;
	int w;
} qq1, qq2;

inline void bfs(int x, int y) 
{
	if( odl[x][y][x][y] == 0 ) return ;
	
	queue<qq> Q;
	qq1.x = x;
	qq1.y = y;
	qq1.w = 1;
	Q.push(qq1);
	odl[x][y][qq1.x][qq1.y] = qq1.w;
	
	while( !Q.empty() ) {
		qq2 = Q.front(); Q.pop();
		
		for(int i=-1; i<=1; ++i) {
			for(int j=-1; j<=1; ++j) {
				if( odl[x][y][qq2.x+i][qq2.y+j] == 0 && !(i==-1 && j==1) && !(i==1 && j==-1) && pole[qq2.x+i][qq2.y+j] == '.' ) {
					qq1.w = qq2.w;
					qq1.x = qq2.x + i;
					qq1.y = qq2.y + j;
					qq1.w++;
					odl[x][y][qq1.x][qq1.y] = qq1.w;
					Q.push(qq1);
				}
			}
		}
		for(int i=-1; i<=1; ++i) {
			for(int j=-1; j<=1; ++j) {
				if( odl[x][y][qq2.x+i][qq2.y+j] == 0 && !(i==-1 && j==1) && !(i==1 && j==-1) && pole[qq2.x+i][qq2.y+j] != 0 && pole[qq2.x+i][qq2.y+j] != '.' ) {
					qq1.w = qq2.w;
					qq1.x = qq2.x + i;
					qq1.y = qq2.y + j;
					odl[x][y][qq1.x][qq1.y] = qq1.w;
					Q.push(qq1);
				}
			}
		}
		
	}
}

int main()
{
	char c;
	for(;;) {
		scanf("%d", &H);		
		for(int i=1; i<=H; ++i) {
			for(int j=1; j<=H+i-1; ++j) {
				while( (c=getchar()) != '.' && (c<'A') );
				pole[i][j] = c;
				odl[i][j][i][j] = 1;
			}
		}
		for(int i=1; i<=H-1; ++i) {
			for(int j=i+1; j<=2*H-1; ++j) {
				while( (c=getchar()) != '.' && (c<'A') );
				pole[H+i][j] = c;
				odl[H+i][j][H+i][j] = 1;
			}
		}
		
		for(int i=1; i<=2*H; ++i) 
			for(int j=1; j<=2*H; ++j) 
				bfs(i,j);
		
		for(int i=1; i<=2*H; ++i) {
			for(int j=1; j<=2*H; ++j) {
				printf("%d ", odl[3][4][i][j]);
			}
			printf("\n");
		}
	}

	return 0;
}
